#include <bits/stdc++.h>
#define maxn 20000005
#define maxm 100005
using namespace std;

int n,m,c;
long long sum;
int b[maxm];
int a[maxn];
int main()
{
    cin>>n>>m;
    for(int i=1;i<=m;++i)cin>>b[i];
    cin>>c;

    for(int i=1;i<=n;++i)a[i]=i;

    for(int i=0;i<=n-m;++i)
    {
        for(int j=1;j<=m;++j)
        {
            a[i+b[j]]=a[i+j];
        }
    }

    for(int i=1;i<=n;++i)
    {
        sum+=((int(pow(c,i))%998244353)*(a[i]%998244353)%998244353);
    }
    cout<<sum;
}